SystemOrganization addCategory: #Project!

Object subclass: #DidaticStructure
	instanceVariableNames: 'id name creator ownerList visible topic'
	classVariableNames: 'StructureId'
	poolDictionaries: ''
	category: 'Project'!

!DidaticStructure commentStamp: 'RFG 5/11/2013 13:53' prior: 0!
Mudar o nome dessa classe. It represents: Lecture U Group U Subject U Courses!

DidaticStructure subclass: #Course
	instanceVariableNames: 'subjectList userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Course commentStamp: 'RFG 5/2/2013 11:43' prior: 0!
Represents a course in the system.!

!Course class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 20:09'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId
	"Creates a new DidaticStructure with an Id, named aString and the creator indicated by anUserId."
	
	| newCourse
	  aTopic
	  sys		 |
	
	newCourse := super newNamed: aName  withId: anId by: anUserId onTopic: aTopicId.
	
	newCourse userList isNil
		ifTrue: [newCourse userList: OrderedCollection new].
		
	newCourse subjectList isNil
		ifTrue: [newCourse subjectList: OrderedCollection new].
		
	sys := System create.
	aTopic := sys findTopic: aTopicId.
	aTopic addCourse: newCourse.
	^newCourse! !

!Course methodsFor: 'inclusion' stamp: 'RFG 5/13/2013 15:38'!
addSubject: anId
	"Adds a subject into the course."

	subjectList add: anId.! !

!Course methodsFor: 'inclusion' stamp: 'RFG 5/13/2013 15:37'!
addUser: anId
	"Adds a user into the course."

	userList add: anId! !

!Course methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:43'!
delete
	"Removes the course from the System."

	| user 
	  system 
	  topic    |
	
	system := System create.
	
	userList do:[:userId |
		user := system findUser: userId.
		user withdrawCourse: (self id).
		].
	
	topic := system findTopic: (self topic).
	topic courseTable removeAt: (self id).! !

!Course methodsFor: 'remotion' stamp: 'RFG 5/13/2013 15:39'!
removeSubject: anId.
	"Removes the subject with the given ID."
	
	subjectList remove: anId! !

!Course methodsFor: 'remotion' stamp: 'RFG 5/13/2013 15:39'!
removeUser: anId.
	"Removes the user with the given ID."
	
	userList remove: anId! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 09:58'!
subjectList
	"Returns the list of subjects included in the course."

	^subjectList.! !

!Course methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:07'!
subjectList: aListOfIds
	"Sets the list of subjects included in the course."

	subjectList := aListOfIds.! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:36'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Course methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:07'!
userList: aListOfIds
	"Sets the list of inscribed users."

	userList := aListOfIds.! !

!DidaticStructure class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 12:21'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId
	"Creates a new DidaticStructure with an Id, named aString and the creator indicated by anUserId."

	| newDidaticStructure |
	
	newDidaticStructure := self new.
	
	newDidaticStructure id: anId.
	newDidaticStructure name: aName.
	newDidaticStructure creator: anUserId.
	newDidaticStructure topic: aTopicId.
	newDidaticStructure visible: False. 
	
	newDidaticStructure ownerList isNil
		ifTrue: [newDidaticStructure ownerList: OrderedCollection new].
	
	^newDidaticStructure.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 08:03'!
creator
	"Returns the creator."

	^creator.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:08'!
creator: anId
	"Sets the ID of the creator."

	creator := anId.! !

!DidaticStructure methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:08'!
delete
	"Removes the didatic structure from the system."

	^self subclassResponsibility.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:22'!
id
	"Returns the id."

	^id.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:22'!
id: anID
	"Sets the id."
	
	id := anID.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:13'!
name
	"Returns the name."

	^name.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:14'!
name: aString
	"Sets the name."

	name := aString.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 08:07'!
ownerList
	"Returns the list of owners."

	^ownerList.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:08'!
ownerList: aListOfIds
	"Sets the list of owners."

	ownerList := aListOfIds.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 14:26'!
topic
	"Returns the topic."

	^topic.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 14:26'!
topic: aTopic
	"Sets the topic."

	topic := aTopic.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:01'!
visible
	"Returns whether the structure is visible or not by non-owners users"

	^visible.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:03'!
visible: boolean
	"Sets whether the structure is visible or not by non-owners users"

	visible := boolean.! !

DidaticStructure subclass: #Group
	instanceVariableNames: 'userList instructor subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Group commentStamp: 'RFG 5/9/2013 13:46' prior: 0!
Represents a group in the system. Set of students at inscribed in a subject with a instructor.!

!Group class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 14:23'!
newNamed: aName withId: anId by: anUserId onSubject:  anSubjectId andInstructor: anInstructorId
	"Creates a new Group in a Subject and a instructor"
	
	| newGroup
	  system 
	  topicId     
	  subject     |
	
	system := System create.
	subject := system findSubject: anSubjectId.
	topicId := subject topic.
	newGroup := super newNamed: aName withId: anId by: anUserId onTopic: topicId.
	newGroup instructor: anInstructorId.
	newGroup subject: anSubjectId.
	
	newGroup userList isNil
		ifTrue: [newGroup userList: OrderedCollection new].
	subject addGroup: newGroup.
		
	^newGroup.
	! !

!Group methodsFor: 'adding' stamp: 'RFG 5/13/2013 15:58'!
addUser: anId
	"Adds a user into the group."

	userList add: anId! !

!Group methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:01'!
delete
	"Removes a group from the system."

	| subject
	  sys
	  subjectId
	  groupId   |
	
	groupId := self id.
	subjectId := self subject.
	userList do:[:user |
		user leaveGroup: groupId.
		].
	sys := System create.
	subject := sys findSubject: subjectId.
	subject groupTable removeKey: groupId.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:10'!
instructor
	"Returns the group's instructor."

	^instructor.! !

!Group methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:09'!
instructor: anUserId
	"Sets the group's instructor."

	instructor := anUserId.! !

!Group methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:29'!
removeUser: anId
	"Removes the user with the given ID."
	
	| userId 
	  user 
	  system |
	
	userId := userList removeAt: anId.
	system := System create.
	user := system findUser: userId.
	user groupList remove: (self id).
	! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:10'!
subject
	"Returns the group's subject."

	^subject.! !

!Group methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:09'!
subject: anSubjectId
	"Sets the group's subject."

	subject := anSubjectId.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:54'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Group methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:09'!
userList: aListOfIds
	"Sets the list of inscribed users."

	userList := aListOfIds.! !

DidaticStructure subclass: #Lecture
	instanceVariableNames: 'subject userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Lecture commentStamp: 'RFG 5/10/2013 18:02' prior: 0!
Represents a Lecture of a Subject!

!Lecture class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 14:40'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId onSubject:  aSubjectId 
	"Creates a new Lecture in a Subject"

	| newLecture    
	  sys             |
	
	newLecture := super newNamed: aName withId: anId by: anUserId onTopic: aTopicId.
	newLecture subject: aSubjectId.
	
	newLecture userList isNil
		ifTrue: [newLecture subjectList: OrderedCollection new].
		
	sys := System create.
	(sys findSubject: aSubjectId) addLecture: newLecture.
	
	^newLecture.! !

!Lecture methodsFor: 'deletion' stamp: 'RFG 5/13/2013 15:32'!
delete
	"Removes a lecture from the system."

	| subject
	  sys       |
	
	sys := System create.
	subject := sys findSubject: (self subject).
	subject lectureTable removeKey: (self id).! !

!Lecture methodsFor: 'remotion' stamp: 'RFG 5/13/2013 18:46'!
removeUser: anId.
	"Removes the user with the given ID."
	
	userList remove: anId.! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:43'!
subject
	"Returns the lecture's subject."

	^subject.! !

!Lecture methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:10'!
subject: anSubjectId
	"Sets the lecture's subject."

	subject := anSubjectId.! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:43'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Lecture methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:10'!
userList: aListOfIds
	"Sets the list of inscribed users."

	userList := aListOfIds.! !

DidaticStructure subclass: #Subject
	instanceVariableNames: 'groupTable lectureTable responsible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Subject commentStamp: 'RFG 5/6/2013 15:55' prior: 0!
Represents a Subject in the system.!

!Subject class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 15:14'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId

	"Creates a new Subject managed by a teacher responsible. "

	| newSubject |
	
	newSubject := self newNamed: aName withId: anId by: anUserId onTopic: aTopicId managedBy: anUserId.
	
	^newSubject.! !

!Subject class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 15:17'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId managedBy: responsibleId
	"Creates a new Subject managed by a teacher responsible. "

	| newSubject 
	  topic
	  sys             |
	
	newSubject := super newNamed: aName withId: anId by: anUserId onTopic: aTopicId.
	newSubject responsible: responsibleId.
	
	newSubject groupTable isNil
		ifTrue: [newSubject groupTable: Dictionary new].
	
	newSubject lectureTable isNil
		ifTrue: [newSubject lectureTable: Dictionary new].
		
	sys := System create.
	
	topic := sys findTopic: aTopicId.
	topic addSubject: newSubject.
	
	^newSubject.! !

!Subject methodsFor: 'adding' stamp: 'RFG 5/13/2013 14:25'!
addGroup: aGroup
	"Adds the group to the subject list."

	groupTable at: aGroup id put: aGroup.! !

!Subject methodsFor: 'adding' stamp: 'RFG 5/13/2013 14:28'!
addLecture: aLecture
	"Adds the lecture to the subject list."

	groupTable at: aLecture id put: aLecture.! !

!Subject methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:51'!
delete
	"Removes the subject from the system."
	
	| system
	  topic    |
	
	groupTable do: [:group | group delete.].
	lectureTable do: [:lecture| lecture delete].
	
	system := System create.
	topic := system findTopic: (self topic).
	topic subjectTable removeAt: (self id).! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/13/2013 19:03'!
findGroup: anGroupId
	"Returns a group at id if present."

	^(groupTable at: anGroupId).! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/13/2013 19:04'!
findLecture: anLectureId
	"Returns a lecture at if present."

	^(lectureTable at: anLectureId).! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/12/2013 09:13'!
groupTable
	"Returns the table of groups that study this discipline."

	^groupTable.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/12/2013 09:13'!
groupTable: aDict
	"Sets the table of groups that study this discipline."

	groupTable := aDict.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:30'!
lectureTable
	"Returns the table of lectures that of this discipline."

	^lectureTable.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:29'!
lectureTable: aDict
	"Sets the table of lectures of this discipline."

	lectureTable := aDict.! !

!Subject methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:00'!
removeGroup: aGroupId
	"Removes the user with the given ID"
	
	| group |
	group := self findGroup: aGroupId.
	group delete.! !

!Subject methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:04'!
removeLecture: aLectureId
	"Removes the lecture with the given ID"
	
	| lecture |
	lecture := self findLecture: aLectureId.
	lecture delete.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/12/2013 09:14'!
responsible
	"Returns the teacher responsible for this subject."

	^responsible.! !

!Subject methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:11'!
responsible: anUserId
	"Sets the teacher responsible for this subject."

	responsible := anUserId.! !

DidaticStructure subclass: #Topic
	instanceVariableNames: 'courseTable subjectTable moderatorList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Topic commentStamp: 'RFG 5/2/2013 13:44' prior: 0!
Represents a topic in the system.!

!Topic class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 19:53'!
newNamed: aName withId: anId by: anUserId
	"Creates a new topic with the given name and id."
	
	|newTopic
	 sys		|
	
	newTopic := super newNamed: aName withId: anId by: anUserId onTopic: anId .
	
	newTopic courseTable isNil
		ifTrue: [newTopic courseTable: Dictionary new].
		
	newTopic subjectTable isNil
		ifTrue: [newTopic subjectTable: Dictionary new].
	
	newTopic moderatorList isNil
		ifTrue: [newTopic moderatorList: OrderedCollection new].
		
	sys := System create.
	sys addTopic: newTopic.
	
	^newTopic.! !

!Topic methodsFor: 'adding' stamp: 'AP 5/11/2013 23:34'!
addCourse: aCourse

	courseTable at: aCourse id put: aCourse.

	! !

!Topic methodsFor: 'adding' stamp: 'AP 5/12/2013 20:54'!
addModerator: aModeratorId

	moderatorList add: aModeratorId.! !

!Topic methodsFor: 'adding' stamp: 'RFG 5/13/2013 13:09'!
addSubject: aSubject
	"Adds the subject to the subject list."

	subjectTable at: aSubject id put: aSubject.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:16'!
courseTable
	"Returns the dictionary of courses of the topic."

	^courseTable.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:17'!
courseTable: aDictionary
	"Sets the dictionary of courses of the topic."

	courseTable := aDictionary.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/5/2013 08:50'!
creator
	"Returns the topic creator."

	^creator.! !

!Topic methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:28'!
creator: anUserId.
	"Sets the topic creator."

	creator := anUserId.! !

!Topic methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:52'!
delete
	"Removes the topic from the system."
	
	| system
	  topic    |
	
	courseTable do: [:course | course delete.].
	subjectTable do: [:subject| subject delete].
	
	system := System create.
	topic := system findTopic: (self topic).
	system removeTopic: (self id).! !

!Topic methodsFor: 'accessing' stamp: 'AP 5/12/2013 15:25'!
findCourse: aCourseId

	^courseTable at: aCourseId ifAbsent:[^nil].! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:12'!
findSubject: aSubjectId

	^subjectTable at: aSubjectId ifAbsent:[^nil].! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:55'!
id
	"Returns the topic id."

	^id.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:56'!
id: anId
	"Sets the topic id."

	id := anId.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:44'!
moderatorList
	"Returns the list of moderators of the topic."

	^moderatorList.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:43'!
moderatorList: anOrderedCollection
	"Sets the list of moderators of the topic."

	moderatorList := anOrderedCollection.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:15'!
name
	"Returns the topic name."

	^name.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:15'!
name: aName.
	"Sets the topic name."

	name := aName.! !

!Topic methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:43'!
removeCourse: aCourseId
	"Removes the course with the given ID"
	
	| course |
	course := self findGroup: aCourseId.
	course delete.! !

!Topic methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:45'!
removeSubject: aSubjectId
	"Removes the subject with the given ID"
	
	| subject |
	subject := self findSubject: aSubjectId.
	subject delete.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:42'!
subjectTable
	"Returns the dictionary of subjects of the topic."

	^subjectTable.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:41'!
subjectTable: aDictionary
	"Sets the dictionary of subjects of the topic."

	subjectTable := aDictionary.! !

Object subclass: #System
	instanceVariableNames: 'TopicTable TopicToBeAproved UserTable'
	classVariableNames: 'Id Single'
	poolDictionaries: ''
	category: 'Project'!

!System commentStamp: 'RFG 5/2/2013 13:21' prior: 0!
The main class representing the own system.!

!System class methodsFor: 'initialization' stamp: 'RFG 5/13/2013 15:08'!
create
	"Creates an empty system."
	
	Single isNil
		ifTrue: [
			Single := self new.
			Single TopicTable: Dictionary new.
			Single UserTable: Dictionary new.
			Single TopicToBeAproved:  OrderedCollection new.
			].
		^Single.! !

!System class methodsFor: 'id management' stamp: 'RFG 5/13/2013 20:12'!
nextId
	"Returns the next id avaliable."

	Id isNil
		ifTrue:[Id := 0]
		ifFalse:[Id := Id + 1].
	^Id.! !

!System class methodsFor: 'initialization' stamp: 'RFG 5/13/2013 15:11'!
reset
	"Re-creates an empty system."
	
	| newSys |
	Single := nil.
	newSys := System create.
	^newSys.
	
	! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:54'!
TopicTable
	"Returns the dictionary with all topics."

	^TopicTable.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:54'!
TopicTable: aDictionary
	"Sets the dictionary with all topics."

	TopicTable :=  aDictionary! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 15:05'!
TopicToBeAproved: aCollection
	"Sets the orderedCollection with all topics that aren't aproved yet."

	^TopicToBeAproved :=  aCollection! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:17'!
UserTable
	"Returns the dictionary with all users."

	^UserTable.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:13'!
UserTable: aDictionary
	"Sets the system user table."

	UserTable := aDictionary.! !

!System methodsFor: 'adding' stamp: 'RFG 5/13/2013 13:03'!
addTopic: aTopic

	TopicTable at: aTopic id put: aTopic.
	TopicToBeAproved addLast: aTopic id.! !

!System methodsFor: 'adding' stamp: 'RFG 5/13/2013 13:03'!
addUser: anUser

	UserTable at: anUser id put: anUser  .! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 13:53'!
findCourse: anId
	"Returns a course with the given ID."
	
	| anArray
	  aTopic
	  aCourse
	  index   |
	
	index := 1.
	anArray := TopicTable associations.
	[index <= anArray size]
	whileTrue: [
		aTopic := anArray at: index.
		aCourse := aTopic value findCourse: anId.
		aCourse notNil
		ifTrue:[
			^aCourse
			].
		index := index +1
		].
		^(KeyNotFound key: anId) signal.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:08'!
findGroup: anId
	"Returns a group with the given ID."
	
	|isThere group|
	TopicTable do:  [:topic |
		topic subjectTable do: [:subject |
			isThere := subject groupTable includesKey: anId.
			isThere ifTrue:[
				group := subject groupTable at: anId]
		].
	].
	group isNil 
		ifTrue:[^(KeyNotFound key: anId) signal.]
		ifFalse:[^group].
	! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:13'!
findSubject: anId
	"Returns a subject with the given ID."
	
	| anArray
	  aTopic
	  aSubject
	  index     |
	
	index := 1.
	anArray := TopicTable associations.
	[index <= anArray size]
	whileTrue: [
		aTopic := anArray at: index.
		aSubject := aTopic value findSubject: anId.
		aSubject notNil
		ifTrue:[
			^aSubject
			].
		index := index +1
		].
		^(KeyNotFound key: anId) signal.! !

!System methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:13'!
findTopic: anId

	^TopicTable at: anId! !

!System methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:13'!
findUser: anId

	^UserTable at: anId! !

!System methodsFor: 'removing' stamp: 'AP 5/12/2013 21:27'!
removeTopic: anId
	"Remove a Topic from the System"
	TopicTable removeKey: anId! !

!System methodsFor: 'removing' stamp: 'AP 5/12/2013 21:27'!
removeUser: anId
	"Remove an user from the System"
	UserTable removeKey: anId! !

!System methodsFor: 'accessing' stamp: 'AP 5/11/2013 21:53'!
topicToModerator
	"Gives a topic for the moderator analysis"
	^TopicToBeAproved at: 1! !

Object subclass: #User
	instanceVariableNames: 'id name courseList groupList contentList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!User commentStamp: 'RFG 5/2/2013 11:22' prior: 0!
Represents a user in the system.!

User subclass: #Moderator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Moderator commentStamp: 'RFG 5/11/2013 12:24' prior: 0!
Represents a topic moderator in the system.!

Moderator subclass: #Administrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Administrator commentStamp: 'RFG 5/11/2013 14:52' prior: 0!
Represents special users who can create topics and erase/create anything.!

!Administrator methodsFor: 'creation' stamp: 'RFG 5/13/2013 12:38'!
createTopic: aName withId: anId by: userId

	| sys
	  aTopic|
	
	aTopic := Topic  newNamed: aName withId: anId by: userId.
	sys := System create.
	sys addTopic: aTopic.! !

!Administrator methodsFor: 'creation' stamp: 'AP 5/12/2013 20:38'!
createTopic: aName withId: anId created: userId

	| sys
	  aTopic|
	
	aTopic := Topic  newNamed: aName withId: anId by: userId.
	sys := System create.
	sys addTopic: aTopic.! !

!Administrator methodsFor: 'creation' stamp: 'RFG 5/13/2013 16:03'!
createUser: aName withId: anId
	
	| newUser 
	  sys        |
	
	newUser := User newNamed: aName withId: anId.
	sys := System create.
	sys addUser: newUser.! !

!Administrator methodsFor: 'nominate' stamp: 'RFG 5/13/2013 20:33'!
nominateAdministrator: anUser
	"Give moderator privileges to an user"

	| newAdministrator
	  sys			      |
	
	newAdministrator := Administrator newNamed: anUser name withId: anUser id.
	newAdministrator courseList: anUser courseList. 
	newAdministrator groupList: anUser groupList.
	newAdministrator contentList: anUser contentList.
	
	sys := System create.
	sys removeUser: anUser id.
	sys addUser: newAdministrator id.
	
	^newAdministrator.! !

!Administrator methodsFor: 'nominate' stamp: 'RFG 5/13/2013 20:29'!
nominateModerator: anUser onTopic: aTopicId
	"Give moderator privileges to an user"

	| newModerator 
	  sys			
	  aTopic		|
	
	newModerator := Moderator newNamed: anUser name withId: anUser id.
	newModerator courseList: anUser courseList. 
	newModerator groupList: anUser groupList.
	newModerator contentList: anUser contentList.
	
	sys := System create.
	sys removeUser: anUser id.
	sys addUser: newModerator.
	
	aTopic := sys findTopic: aTopicId.
	aTopic addModerator: newModerator id.
	
	^newModerator.! !

!Moderator methodsFor: 'publishing' stamp: 'AP 5/11/2013 21:55'!
aproveTopic
	"Make a topic visible for the public. In other words, the moderator aproves a topic
	using this function"
	| anId
	  aTopic
	  sys	|
	
	sys := System create.
	anId := sys topicToModerator.
	aTopic := sys findTopic: anId.
	aTopic visible: true.
! !

!Moderator methodsFor: 'publishing' stamp: 'RFG 5/13/2013 20:37'!
hide: aDidaticStructure
	"Turns a didatic structure invisible to all commom users non-owners."

	| topic 
	  system 
	  mod     |
	
	system := System create.
	topic :=  system findTopic: aDidaticStructure topic.
	
	mod := topic moderatorList at: self id.
	mod isNil
		ifFalse:[aDidaticStructure visible: True].
		! !

!Moderator methodsFor: 'publishing' stamp: 'RFG 5/13/2013 20:36'!
publish: aDidaticStructure
	"Turns a didatic structure invisible to all commom users non-owners."

	| topic 
	  system
	  mod     |
	
	system := System create.
	topic :=  system findTopic: aDidaticStructure topic.
	
	mod := topic moderatorList at: self id.
	mod isNil
		ifFalse:[aDidaticStructure visible: True].! !

!User class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 19:58'!
newNamed: aName withId: anId
	"comment stating purpose of message"
	
	|newUser
	 sys	   |
		
	newUser := self new.
	newUser id: anId.
	newUser name: aName.
	newUser groupList isNil
		ifTrue: [newUser groupList: OrderedCollection new].
	newUser courseList isNil
		ifTrue: [newUser courseList: OrderedCollection new].
	newUser contentList isNil
		ifTrue: [newUser contentList: OrderedCollection new].
		
	sys := System create.
	sys addUser: newUser.
	^newUser! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 16:31'!
contentList
	"Returns a list with the IDs of the Contents owned by the user."

	^contentList.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 18:15'!
contentList: anOrderedCollection
	"Sets the user content list."

	contentList := anOrderedCollection.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 16:39'!
courseList
	"comment stating purpose of message"

	^courseList.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 18:19'!
courseList: anOrderedCollection
	"Sets the user content list."

	courseList := anOrderedCollection.! !

!User methodsFor: 'remotion' stamp: 'RFG 5/13/2013 20:02'!
delete
	"Removes the user from the system."
	| sys |
	sys := System create.
	sys  removeUser: self Id.
	courseList do: [: course| course removeUser: (self id).].
	groupList do:[:group | group removeUser: (self id).].
	! !

!User methodsFor: 'remotion' stamp: 'RFG 5/12/2013 08:25'!
delete: aDidaticStructure
	"Tries to delete a structure."

	aDidaticStructure ownerList remove: id ifAbsent: [Transcript show: 'User can not do that.'].
	aDidaticStructure delete.! !

!User methodsFor: 'subscription' stamp: 'AP 5/13/2013 13:52'!
enrollCourse: courseId
	"Enrolls the user in a course and register this course in the courselist."
	
	| sys
	  aCourse |
	
	self courseList add: courseId.
	sys := System create.
	aCourse := sys findCourse: courseId.
	aCourse addUser: self Id.! !

!User methodsFor: 'subscription' stamp: 'AP 5/12/2013 21:30'!
enterGroup: aGroupId
	"Makes the user part of the group with the given ID."! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 16:30'!
groupList
	"Returns a list with the IDs of the Groups which the user is in."

	^groupList.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 18:16'!
groupList: anOrderedCollection
	"Sets the user group list."

	groupList := anOrderedCollection.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/13/2013 13:00'!
id
	"Returns the user ID."

	^id.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/13/2013 13:01'!
id: anId
	"comment stating purpose of message"

	id := anId.! !

!User methodsFor: 'subscription' stamp: 'RFG 5/13/2013 19:29'!
leaveGroup: aGroupId
	"Makes user leave a group."
	
	| group  
	system |
	
	system := System create.
	group := system findGroup: aGroupId. 
	group removeUser: id.
	groupList remove: aGroupId.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 15:32'!
name
	"Returns the user's name."

	^name.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 15:17'!
name: aName
	"comment stating purpose of message"

	name := aName.! !

!User methodsFor: 'subscription' stamp: 'RFG 5/13/2013 19:34'!
withdrawCourse: aCourseId
	"comment stating purpose of message"
	
	| course 
	system  |
	
	system := System create.
	course := system findCourse: aCourseId. 
	course userList remove: id.
	courseList remove: aCourseId.! !
